local oldTime = 0
local origfunc = MenuPauseRenderer.update
function MenuPauseRenderer:update(...)
	origfunc(self, ...)
	
	if not TeamReview
		or not TeamReview.Review
		or TeamReview.update_available == nil
	then
		self:TeamReviewInit()
	end
	
	if TeamReview.settings['pause_menu'] then
		local apptime = Application:time()
		if apptime - oldTime > (TeamReview.update_interval or 0.1)
			and TeamReview.Review
		then
			TeamReview:Review()
			oldTime = apptime
		end
	else
		TeamReview.alerts = {}
	end
	
	if self.TR and self.TR.review_text then 
		self:clear_review()
	end
		
	for k,v in pairs(TeamReview.alerts or {}) do
		self:add_review_line(v.text, v.color)
	end
end

function MenuPauseRenderer:clear_review()
	for i=1, #self.TR.review_text do
		self._fullscreen_panel:remove(self.TR.review_text[i])
	end
	
	self.TR.review_text = {}
end

function MenuPauseRenderer:add_review_line(text, color)
	self.TR = self.TR or {}
	self.TR.review_text = self.TR.review_text or {}
	self.TR.review_text[#self.TR.review_text + 1] = self._fullscreen_panel:text({
			blend_mode = "add",
			x = 750,
			y = 400 + (#self.TR.review_text * 22),
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			color = color,
			text = text,
			layer = 1
		})
end

function MenuPauseRenderer:TeamReviewInit()
	local thisPath = debug.getinfo(2, "S").source:sub(2)
	local thisDir = string.match(thisPath, '.*/')
	local upDir = thisDir:match('(.*/).-/')
	dofile(thisDir..'TeamReviewData.lua')
	dofile(thisDir..'TeamReview.lua')
	TeamReview.update_available = false
	dofile(upDir..'Updates.lua')
end