local oldTime = 0
local offset_Y = 100
local original_update = MissionBriefingGui.update
function MissionBriefingGui:update(...)
	original_update(self, ...)
	
	if not alive(self._panel) or not alive(self._fullscreen_panel) or not self._enabled then
		return
	end
	
	if self._displaying_asset then
		return
	end

	if game_state_machine:current_state().blackscreen_started and game_state_machine:current_state():blackscreen_started() then
		return
	end
	
	if not TeamReview
		or not TeamReview.Review
		or TeamReview.update_available == nil
		or not self.TR
		or not self.TR.background
	then
		self:TeamReviewInit()
	end
	
	local apptime = Application:time()
	if apptime - oldTime > (TeamReview.update_interval or 0.1) 
		and TeamReview
		and TeamReview.Review
	then
		TeamReview:Review()
		oldTime = apptime
	end
	
	if self.TR and self.TR.review_text then 
		self:clear_review()
	end
		
	for k,v in pairs(TeamReview.alerts or {}) do
		self:add_review_line(v.text, v.color)
	end
	
	if TeamReview.settings.background then
		if self.TR.review_text and #self.TR.review_text > 0 then
			self.TR.background:set_h(20 + (#self.TR.review_text * 22))
			self.TR.background_rect:set_visible(true)
		else
			self.TR.background_rect:set_visible(false)
		end
	else
		self.TR.background_rect:set_visible(false)
	end
	
	if managers.crime_spree and managers.crime_spree.is_active() then
		if managers.menu_component
			and managers.menu_component._game_chat_gui
		then
			local chat_H = #TeamReview.alerts > 4 and 10+4-#TeamReview.alerts or 10
			chat_H = chat_H > 5 and chat_H or 6
			if managers.menu_component._game_chat_gui._max_lines ~= chat_H then
				managers.menu_component._game_chat_gui:set_max_lines(chat_H)
			end
		end
	end
end

function MissionBriefingGui:clear_review()
	for i=1, #self.TR.review_text do
		self.TR.background:remove(self.TR.review_text[i])
	end
	
	self.TR.review_text = {}
end

function MissionBriefingGui:add_review_line(text, color)
	self.TR = self.TR or {}
	self.TR.review_text = self.TR.review_text or {}
	self.TR.review_text[#self.TR.review_text + 1] = self.TR.background:text({
			blend_mode = "add",
			x = 10,
			y = 10 + (#self.TR.review_text * 22),
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			color = color,
			text = text,
			layer = 10
		})
end

function MissionBriefingGui:TeamReviewInit()
	local thisPath = debug.getinfo(2, "S").source:sub(2)
	local thisDir = string.match(thisPath, '.*/')
	local upDir = thisDir:match('(.*/).-/')
	dofile(thisDir..'TeamReviewData.lua')
	dofile(thisDir..'TeamReview.lua')
	TeamReview.update_available = false
	dofile(upDir..'Updates.lua')
	
	if managers.crime_spree and managers.crime_spree.is_active() then
		offset_Y = 265
	end
	
	self.TR = self.TR or {}
	
	local w = self._fullscreen_panel:w() * 0.45
	self.TR.background = self._fullscreen_panel:panel({
		name = "tr_background",
		h = 100,
		layer = 9,
		w = w --0.35
	})
		
	self.TR.background_rect = self.TR.background:rect({
		halign = "grow",
		valign = "grow",
		layer = 1,
		color = Color(0.5, 0, 0, 0)
	})


	self.TR.background:set_rightbottom(40+w, 144)
	self.TR.background:set_top(offset_Y - 10)
	self.TR.background:set_visible(true)
end